/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_groups
#define headerfile_winix_core_groups

#include <map>

#include "group.h"
#include "ugcontainer.h"
#include "db/db.h"



class Groups
{
typedef UGContainer<Group> Table;

Table table;

public:

	typedef Table::Iterator Iterator;
	typedef Table::SizeType SizeType;

	Groups();
	void Clear();
	void ReadGroups(Db * db);
	Group * GetGroup(long group_id);
	Group * GetGroup(const std::wstring & name);
	long GetGroupId(const std::wstring & name);
	Iterator Begin();
	Iterator End();
	SizeType Size();
	bool Remove(long group_id);

};









#endif
