/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_logmanipulators
#define headerfile_winix_core_logmanipulators


/*
	log1 - the first level
	log2
	log3
	log4 - the last level (debug level)
	logend        - the end of a line
	logendrequest - end of a current request
	logsave       - current log buffer is saved and cleared

	manipulators used by the session logger (SLog)
	loginfo    - normal info to a user
	logerror   - we are reporting an error
	logwarning - we are reporting a warning

	make sure that loginfo, logerror and logwarning have values less than 32 (space)
	their are used as control codes in a string
*/
enum LogManipulators
{
	log1,
	log2,
	log3,
	log4,
	logend,
	logendrequest,
	logsave,

	loginfo,
	logerror,
	logwarning
};


#endif

