/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2011, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_requesttypes
#define headerfile_winix_core_requesttypes

#include <string>
#include <vector>
#include <map>


// !! narazie uzywane tylko w post multi parserze
// dodac do zwyklego parsera post
#define WINIX_POSTTABLE_MAXSIZE 50



struct PostFile
{
	std::wstring filename;		// original file name
	std::wstring tmp_filename;	// file with content (in /tmp)
	size_t file_size;
};


// parameters from get name:value
struct Param
{
	std::wstring name;
	std::wstring value;
};


// some global types used by Request class
typedef std::map<std::wstring, std::wstring> PostTab;
typedef std::map<std::wstring, PostFile>     PostFileTab;
typedef std::vector<Param>                   ParamTab;

typedef std::map<std::string, std::string>   CookieTab;



#endif
