/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_core_sessionparser
#define headerfile_winix_core_sessionparser

#include <fstream>
#include <string>
#include "session.h"
#include "sessioncontainer.h"
#include "users.h"



class SessionParser
{
public:

	bool Parse(const char * path, SessionContainer & container);
	bool Parse(const std::string & path, SessionContainer & container);
	void SetUsers(Users * pusers);

private:
	
	Users * users;

	bool Parse(SessionContainer & container);
	void MakeSession(long id, long user_id, SessionContainer & container);

	bool IsWhite(int c);
	bool IsDigit(int c);
	void SkipWhite();
	void SkipLine();

	long ReadLong();

	std::ifstream file;
	int last; // last character

};


#endif

