/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2011, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "ckeditor.h"
#include "functions.h"



namespace Fun
{

Ckeditor::Ckeditor()
{
	fun.url = L"ckeditor";
}

void Ckeditor::Init()
{
	system->AddCommonFileToVar(L"winix/ckeditor_full.js", L"ckeditor_full.js");
	system->AddCommonFileToVar(L"winix/ckeditor_winix.js", L"ckeditor_winix.js");
}

bool Ckeditor::HasAccess()
{
	return functions->fun_emacs.HasAccess();
}


void Ckeditor::MakeGet()
{
	cur->session->last_css.clear();
	int parcss = system->mounts.MountParCss();

	if( cur->mount->param[parcss].defined )
		cur->session->last_css = cur->mount->param[parcss].arg;
}


void Ckeditor::MakePost()
{
	functions->fun_emacs.MakePost();
}




} // namespace
