/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "locale.h"
#include "templates/templates.h"



namespace Fun
{

Locale::Locale()
{
	fun.url = L"locale";
}



bool Locale::HasAccess()
{
	return cur->session->puser != 0;
}



void Locale::MakePost()
{
	if( cur->session->puser )
	{
		size_t locale_id = size_t(Toi(cur->request->PostVar(L"localeid")));

		if( TemplatesFunctions::locale.HasLanguage(locale_id) )
		{
			cur->session->puser->locale_id = locale_id;
			db->ChangeUserLocale(cur->session->puser->id, locale_id);
			TemplatesFunctions::locale.SetCurLang(locale_id);
		}
		else
		{
			log << log1 << "Locale: incorrect locale id: " << locale_id << logend;
		}
	}
}



void Locale::MakeGet()
{
}




} // namespace
