/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_passwd
#define headerfile_winix_functions_passwd

#include "functionbase.h"
#include "core/user.h"


namespace Fun
{


class Passwd : public FunctionBase
{
public:

	Passwd();
	bool HasAccess();
	void MakePost();

	bool IsPasswordCorrect(const std::wstring & pass, const std::wstring & conf_pass, bool use_ses_log = false);
	bool ChangePassword(long user_id, const std::wstring & new_password);

private:

	UserPass up;

	void ChangePassword(User * puser);

};


} // namespace

#endif
