/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_pw
#define headerfile_winix_functions_pw

#include "functionbase.h"


namespace Fun
{


class Pw : public FunctionBase
{
public:

	Pw();

	bool HasAccess();
	void MakePost();
	void MakeGet();

	bool ActivateAccount(const std::wstring & login, long code, bool use_ses_log = false);
	bool ResetPassword(const std::wstring & login, long code, bool use_ses_log = false, bool only_check_access = false);

private:

	bool ActivateAccount(User * puser, long code, bool use_ses_log);
	bool ResetPassword(User * puser, long code, bool use_ses_log);
	void ActivateAccount();
	bool SetNewPassword(User * puser, bool use_ses_log);
	bool ResetPassword(User * puser, long code, bool use_ses_log, bool only_check_access);
	void ResetPassword();
	void ShowResetPasswordForm();

};


} // namespace

#endif
