/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_plugins_export_edb
#define headerfile_winix_plugins_export_edb

#include <vector>
#include "db/dbbase.h"
#include "export.h"
#include "core/dirs.h"



namespace Export
{



class EDb : public DbBase
{
public:

	void SetDirs(Dirs * pdirs);

	bool GetExport(long user_id, std::vector<Export> & export_tab, bool clear_tab = true);
	bool GetExport(long id, Export & exp);
	bool GetExportDirs(std::vector<ExportDir> & export_tab, bool clear_tab = true);

private:

	Dirs * dirs;

	Export exp;
	ExportDir exp_dir;
	DbTextStream query;
	std::wstring dir_temp;

	int cid;
	int cuser_id;
	int cdir;
	int cftp_id;
	int cftp_dir;
	int cname;
	int cserver;
	int clogin;
	int cpass;
	int cpass_type;
	int ccan_change_ftp_params;
	int ccan_change_dir;
	int chttp_server;

	void SetExportCols(PGresult * r);
	void SetExportValues(PGresult * r, int row, Export & exp);

};


}

#endif
