/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_plugins_export_export
#define headerfile_winix_plugins_export_export

#include <string>



namespace Export
{

struct ExportDir
{
	long id;
	long dir_id;
};



struct Export
{
	long id;
	long user_id;
	std::wstring dir;

	long ftp_id;
	std::wstring ftp_dir;

	std::wstring ftp_name;
	std::wstring ftp_server;
	std::wstring ftp_login;
	std::wstring ftp_pass;
	int ftp_pass_type;

	bool can_change_ftp_params;
	bool can_change_dir;

	std::wstring http_server;
	


	Export()
	{
		Clear();
	}

	void Clear()
	{
		id = user_id = ftp_id = -1;
		ftp_pass_type = 0;

		dir.clear();
		ftp_dir.clear();
		ftp_name.clear();
		ftp_server.clear();
		ftp_login.clear();
		ftp_pass.clear();

		can_change_ftp_params	= false;
		can_change_dir			= false;

		http_server.clear();
	}

};


}

#endif
