/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2012, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_plugins_export_funexport
#define headerfile_winix_plugins_export_funexport

#include "functions/functionbase.h"
#include "db/db.h"
#include "exportinfo.h"


namespace Export
{


class FunExport : public FunctionBase
{
public:

	FunExport();
	void SetExportInfo(ExportInfo * pexport_info);

	bool HasAccess();

	void MakePost();
	void MakeGet();


	void ExportFile(const Item & item);
	void ExportDir(const Item & dir, bool only_non_static_files = false);

private:

	ExportInfo * export_info;
	DbItemQuery iq_dir;
	std::vector<Item> dir_items;

	void Export();


};



} // namespace

#endif

