/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_plugins_export_message
#define headerfile_winix_plugins_export_message

#include <string>



// message types
#define WINIX_PL_EXPORT_TYPE_CREATE_FILE		1
#define WINIX_PL_EXPORT_TYPE_CREATE_FILE_STATIC	2




struct Message
{
	// message type
	int type;

	// original (source) url (if message is WINIX_PL_EXPORT_TYPE_CREATE_FILE)
	// or a file path (WINIX_PL_EXPORT_TYPE_CREATE_FILE_STATIC)
	std::wstring url;

	// source directory
	std::wstring src_dir;

	// output file (directory) name
	// relative path
	// with a slash at the beginning (and at the end if it is a directory)
	std::wstring path;

	std::wstring ftp_server;
	std::wstring ftp_login;
	std::wstring ftp_pass;

	// server on which the site will be visible
	std::wstring http_server;

	// how many errors were with this message
	int errors;

	// shoud be removed
	bool can_remove;


	void Clear()
	{
		type		= 0;
		errors		= 0;
		can_remove	= true;

		url.clear();
		src_dir.clear();
		path.clear();
		ftp_server.clear();
		ftp_login.clear();
		ftp_pass.clear();
		http_server.clear();
	}

};

#endif
