/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_thread_createthread
#define headerfile_winix_plugins_thread_createthread

#include "functions/functionbase.h"
#include "tdb.h"
#include "threadinfo.h"
#include "notify/notify.h"


namespace Thread
{


class CreateThread : public FunctionBase
{
public:

	CreateThread();
	bool HasAccess();
	void MakePost();

	void SetTDb(TDb * ptdb);
	void SetThreadInfo(ThreadInfo * pthread_info);

private:

	TDb * tdb;
	ThreadInfo * thread_info;
	Thread thread;
	NotifyMsg notify_msg;

	void SendNotify(const Item & item);
};


} // namespace

#endif
