/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_thread_showthreads
#define headerfile_winix_plugins_thread_showthreads

#include "functions/functionbase.h"
#include "tdb.h"
#include "threadinfo.h"



namespace Thread
{


class ShowThreads : public FunctionBase
{
public:

	ShowThreads();
	bool HasAccess();
	void MakeGet();

	void SetTDb(TDb * ptdb);
	void SetThreadInfo(ThreadInfo * pthread_info);

	void ReadThreads();




private:

	TDb * tdb;
	ThreadInfo * thread_info;
	std::vector<long> file_id_tab;

	void ReadFiles();
	void CreatePointers();
	void SortPointers();

	struct Sort
	{
		ShowThreads * show_threads;
		int sort_type;
		Sort(ShowThreads * show, int type) : show_threads(show), sort_type(type) {}
		bool operator()(const Item * item1, const Item * item2);
	};

};


} // namespace

#endif
