/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_createticket
#define headerfile_winix_plugins_ticket_createticket

#include "tdb.h"
#include "functions/functionbase.h"
#include "ticketinfo.h"
#include "notify/notify.h"


namespace Ticket
{


class CreateTicket : public FunctionBase
{
public:

	CreateTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	bool HasAccess();
	void MakePost();
	void MakeGet();

private:

	void AddTicket(Ticket & ticket, Item & item);
	void Submit(Ticket & ticket, Item & item);
	void RemoveTmpTicket();
	Ticket & PrepareTicket();
	PT::Space & PrepareSpace();

	TDb * tdb;
	TicketInfo * ticket_info;
	NotifyMsg notify_msg;
};


} // namespace

#endif
