/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "funticket.h"
#include "core/plugin.h"
#include "plugins/thread/pluginmsg.h"



namespace Ticket
{



FunTicket::FunTicket()
{
	fun.url = L"ticket";
}


void FunTicket::SetTDb(TDb * ptdb)
{
	tdb = ptdb;
}


void FunTicket::SetTicketInfo(TicketInfo * pinfo)
{
	ticket_info = pinfo;
}


bool FunTicket::HasAccess()
{
	return cur->request->is_item && system->HasReadAccess(cur->request->item);
}


void FunTicket::MakeGet()
{
	ticket_info->Clear();
	ticket_info->FindCurrentConf();
	ticket_info->ticket = &ticket;
	ticket_info->item   = &cur->request->item;

	tdb->GetTicket(cur->request->item.id, ticket);

	plugin.Call(WINIX_PL_THREAD_PREPARE_THREAD, cur->request->item.id);
}



} // namespace
