/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "core/request.h"
#include "core/misc.h"
#include "functions/functions.h"


namespace TemplatesFunctions
{

static Functions::Iterator winixfun_iter;
static size_t winixfun_curreq = 0;
static Ezc::Stack * winixstack = &empty_stack;



bool man_winixfun_tabcheck()
{
	if( winixfun_curreq != cur->request->id )
	{
		winixfun_curreq = cur->request->id;
		winixfun_iter   = functions->Begin();
	}

return winixfun_iter != functions->End();
}


void man_winixfun_tab(Info & i)
{
	man_winixfun_tabcheck();
	winixstack = i.stack;

	if( i.iter == 0 )
		winixfun_iter = functions->Begin();
	else
	if( winixfun_iter != functions->End() )
		++winixfun_iter;
	
	i.res = winixfun_iter != functions->End();
}


void man_winixfun_tab_index(Info & i)
{
	i.out << (winixstack->iter + 1);
}


void man_winixfun_tab_name(Info & i)
{
	if( man_winixfun_tabcheck() )
		i.out << winixfun_iter->first;
}





static EzcFun::Iterator ezcfun_iter;
static size_t ezcfun_curreq = 0;
static Ezc::Stack * ezcstack = &empty_stack;


bool man_ezcfun_tabcheck()
{
	if( ezcfun_curreq != cur->request->id )
	{
		ezcfun_curreq = cur->request->id;
		ezcfun_iter   = ezc_functions.Begin();
	}

return ezcfun_iter != ezc_functions.End();
}


void man_ezcfun_tab(Info & i)
{
	man_ezcfun_tabcheck();
	ezcstack = i.stack;

	if( i.iter == 0 )
		ezcfun_iter = ezc_functions.Begin();
	else
	if( ezcfun_iter != ezc_functions.End() )
		++ezcfun_iter;

	i.res = ezcfun_iter != ezc_functions.End();
}


void man_ezcfun_tab_index(Info & i)
{
	i.out << (ezcstack->iter + 1);
}


void man_ezcfun_tab_name(Info & i)
{
	if( man_ezcfun_tabcheck() )
		i.out << ezcfun_iter->first;
}







} // namespace TemplatesFunctions



