/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_templates_misc
#define headerfile_winix_templates_misc


#include <vector>
#include <string>
#include "localefilter.h"
#include "ezc.h"
#include "htmltextstream.h"

struct User;


namespace TemplatesFunctions
{


typedef Ezc::Functions<HtmlTextStream> EzcFun;
typedef Ezc::Generator<HtmlTextStream> EzcGen;
typedef Ezc::FunInfo<HtmlTextStream>   Info;

template<class RawType>
HtmlTextStream::RawText<RawType> R(const RawType & par)
{
	return HtmlTextStream::RawText<RawType>(par);
}


void HtmlEscapeFormTxt(HtmlTextStream & out, const std::wstring & in);

void print_hour_min(Info & i,  time_t time);
void print_date_nice(Info & i, const PT::Date & date);
void print_user_name(Info & i, const User * puser, const std::wstring & guest_name);


} // namespace TemplatesFunctions

#endif

