/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "core/request.h"
#include "core/misc.h"



namespace TemplatesFunctions
{

static size_t who_reqid = 0;

SessionContainer::Iterator who_iterator;
size_t who_lp;


bool who_init()
{
	if( who_reqid != cur->request->id )
	{
		who_reqid    = cur->request->id;	
		who_iterator = session_manager->SessionBegin();
		who_lp       = 1;
	}
	
	return who_iterator != session_manager->SessionEnd();
}



void who_tab(Info & i)
{
	who_init();

	if( i.iter != 0 && who_iterator != session_manager->SessionEnd() )
	{
		++who_iterator;
		++who_lp;
	}

	i.res = who_iterator != session_manager->SessionEnd();
}


void who_tab_lp(Info & i)
{
	if( !who_init() )
		return;
	
	i.out << who_lp;
}


void who_tab_user(Info & i)
{
	if( !who_init() )
		return;
	

	if( who_iterator->puser )
		i.out << who_iterator->puser->name;
}



void who_tab_time(Info & i)
{
	if( !who_init() )
		return;
	
	i.out << DateToStr(	0,
						who_iterator->start_date.month,
						who_iterator->start_date.day,
						who_iterator->start_date.hour,
						who_iterator->start_date.min,
						who_iterator->start_date.sec );
}


void who_tab_last_time(Info & i)
{
	if( !who_init() )
		return;
	
	i.out << DateToStr(	0,
						who_iterator->last_date.month,
						who_iterator->last_date.day,
						who_iterator->last_date.hour,
						who_iterator->last_date.min,
						who_iterator->last_date.sec );
}


} // namespace TemplatesFunctions



